import {
	Column,
	Entity,
	Index,
	JoinColumn,
	ManyToOne,
	PrimaryColumn,
	PrimaryGeneratedColumn,
} from "typeorm";
import { id } from "../id.js";
import { Note } from "./note.js";
import type { User } from "./user.js";

@Entity()
@Index(["userId", "ip"], { unique: true })
export class UserIp {
	@PrimaryGeneratedColumn()
	public id: string;

	@Column("timestamp with time zone", {})
	public createdAt: Date;

	@Index()
	@Column(id())
	public userId: User["id"];

	@Column("varchar", {
		length: 128,
	})
	public ip: string;
}
